# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%global python_version %(python -c "import sys; print sys.version[:3]" || echo none)
%{!?python_sitelib: %global python_sitelib %{_prefix}/lib/python%{python_version}/site-packages}
%global need_flex_new %([ "%{__distinit}" == "fc" -a %{__distvers} -ge 7 -o "%{__distinit}" == "rhel" -a %{__distvers} -ge 6 ] && echo 0 || echo 1)
%global need_qt3 %([ "%{__distinit}" == "fc" -a %{__distvers} -gt 8 -o "%{__distinit}" == "rhel" -a %{__distvers} -gt 5 ] && echo 1 || echo 0)
%global need_xfree86 %([ "%{__distinit}%{__distvers}" == "rhl9" -o "%{__distinit}%{__distvers}" == "fc1" ] && echo 1 || echo 0)
%global noarch_subpkg %([ "%{__distinit}" == "fc" -a %{__distvers} -gt 9 -o "%{__distinit}" == "rhel" -a %{__distvers} -gt 5 ] && echo 1 || echo 0)

Name:		xxdiff
Version:	3.2
Release:	20.0.cf.%{__distinit}%{__distvers}
Group:		Applications/Text
License:	GPLv2+
Summary:	Graphical file and directories comparator and merge tool
URL:		http://furius.ca/xxdiff/
# The original tarball can be found at http://furius.ca/downloads/xxdiff/releases/xxdiff-3.2.tar.bz2
# This tarball has the doc/screenshots directory removed as the images in that directory
# cannot be redistributed without permission
Source0:	xxdiff-%{version}-noscreenshots.tar.bz2
Patch0:		xxdiff-3.2-c++-headers.patch
Patch1:		xxdiff-3.2-string-constants.patch
Patch2:		xxdiff-3.2-python-2.2.patch
Patch3:		xxdiff-3.2-python-2.3.patch
Patch4:		xxdiff-3.2-c-linkage.patch
BuildRequires:	bison
%if %{need_flex_new}
BuildRequires:	flex-new
%else
BuildRequires:	flex
%endif
%if %{need_qt3}
BuildRequires:	qt3-devel
%else
BuildRequires:	qt-devel >= 3
%endif
# Missing dep in RHL9 and FC1 qt3-devel
%if %{need_xfree86}
BuildRequires:	XFree86-devel
%endif
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)

%description
xxdiff is a graphical browser for viewing the differences between two or three
files, or between two directories, and can be used to produce a merged version.

%package tools
Summary:	Useful scripts built around xxdiff
Group:		Applications/Text
Requires:	%{name} = %{version}-%{release}
# Python dependencies keep changing
%if "%{python_version}" == "2.2"
Requires:	%{_libdir}/python2.2
%endif
%if "%{python_version}" == "2.3"
Requires:	python-abi = 2.3
%endif
BuildRequires:	python2-devel
%if %{noarch_subpkg}
BuildArch:	noarch
%endif

%description tools
This package provides a number of scripts that are used to perform a variety of
tasks that all involve getting user verification and feedback using the xxdiff
graphical differences viewer.

%prep
%setup -q

# Remove redundant shellbangs from python lib files
find lib/python/xxdiff -name '*.py' ! -name svnforeign.py |
	xargs sed -i -e '/^#!\/usr\/bin\/env python$/d'

# Fix old fashioned header inclusion
%patch0 -p1 -b .headers

# Fix conversions of string constants to char*
%patch1 -p1 -b .strings

# Backport to older python versions
%if "%{python_version}" == "2.2"
%patch2 -p1 -b .py22
%patch3 -p1 -b .py23
%endif
%if "%{python_version}" == "2.3"
%patch3 -p1 -b .py23
%endif

# Fix FTBFS with gcc 4.7
%patch4

%build
unset QTDIR || : ; . /etc/profile.d/qt.sh
export QTLIB=${QTDIR}/lib QTINC=${QTDIR}/include
cd src
make -f Makefile.bootstrap makefile
make \
%if %{need_flex_new}
	CFLAGS="%{optflags} -I%{_includedir}/flex-new" \
	CXXFLAGS="%{optflags} -I%{_includedir}/flex-new" \
	LFLAGS="-L%{_libdir}/flex-new" \
	LEX=flex-new \
%else
	CFLAGS="%{optflags}" \
	CXXFLAGS="%{optflags}" \
%endif
	%{_smp_mflags}
cd -

# Python tools
python setup.py build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_bindir}
install -m 755 bin/xxdiff %{buildroot}%{_bindir}

# Python tools
python setup.py install -O1 --skip-build --root %{buildroot}

# Remove last redundant shellbang
sed -i -e '/^#!\/usr\/bin\/env python$/d' \
	%{buildroot}%{python_sitelib}/xxdiff/scripts/svnforeign.py

# See if there's any egg-info
if [ -f %{buildroot}%{python_sitelib}/xxdiff*.egg-info ]; then
	echo %{buildroot}%{python_sitelib}/xxdiff*.egg-info |
		sed -e 's|^%{buildroot}||'
fi > egg-info

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc doc index.html
%doc CHANGES COPYING README TODO VERSION
%{_bindir}/xxdiff

%files -f egg-info tools
%defattr(-,root,root,-)
%{python_sitelib}/xxdiff/
%{_bindir}/svn-foreign
%{_bindir}/xx-cond-replace
%{_bindir}/xx-cvs-diff
%{_bindir}/xx-cvs-revcmp
%{_bindir}/xx-diff-proxy
%{_bindir}/xx-encrypted
%{_bindir}/xx-filter
%{_bindir}/xx-find-grep-sed
%{_bindir}/xx-match
%{_bindir}/xx-pyline
%{_bindir}/xx-rename
%{_bindir}/xx-sql-schemas
%{_bindir}/xx-svn-diff
%{_bindir}/xx-svn-resolve

%changelog
* Mon Aug  5 2013 Paul Howarth <paul@city-fan.org> 3.2-20.0.cf
- rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Feb 23 2013 Paul Howarth <paul@city-fan.org> 3.2-19.0.cf
- rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Jul 24 2012 Paul Howarth <paul@city-fan.org> 3.2-18.0.cf
- rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu May  3 2012 Paul Howarth <paul@city-fan.org> 3.2-17.0.cf
- fix FTBFS with gcc 4.7

* Mon Aug  1 2011 Paul Howarth <paul@city-fan.org> 3.2-15.0.cf
- BR: python2-devel rather than just python-devel
- nobody else likes macros for commands
- fix dist tag for CentOS 6 and Scientific Linux

* Mon Feb 14 2011 Paul Howarth <paul@city-fan.org> 3.2-14.0.cf
- rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Jul 28 2010 Paul Howarth <paul@city-fan.org> 3.2-13.1.cf
- rebuild for python 2.7 in Rawhide

* Wed May 12 2010 Paul Howarth <paul@city-fan.org> 3.2-13.0.cf
- rebuild for RHEL-6

* Mon Feb 22 2010 Paul Howarth <paul@city-fan.org> 3.2-12.0.cf
- dist tag for Rawhide no longer needs special-casing

* Fri Jul 31 2009 Paul Howarth <paul@city-fan.org> 3.2-11.0.cf
- rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jun 17 2009 Paul Howarth <paul@city-fan.org> 3.2-10.0.cf
- start building for current Fedora releases again
- strip non-distributable screenshots from tarball
- use %%{optflags} in all builds
- fix the multitude of warnings about string constants converted to 'char*'
- make the tools subpackage arch-independent on Fedora 10 onwards
- try to fix the remaining python 2.2/2.3 compatibility issues
- add buildreq XFree86-devel for RHL9/FC1 (missing dep of qt3-devel)

* Sun Jun 22 2008 Paul Howarth <paul@city-fan.org> 3.2-6
- add note about no longer building for recent Fedora versions since
  xxdiff is now included in Fedora

* Wed Apr 23 2008 Paul Howarth <paul@city-fan.org> 3.2-5
- buildrequire qt3-devel on Fedora 9 onwards
- replace C headers with C++ versions where necessary
- include python egg-info where available

* Wed Nov  7 2007 Paul Howarth <paul@city-fan.org> 3.2-4
- fix dist tag for Fedora 7 onwards
- clarify license as GPL version 2 or later
- buildreq and use flex rather than flex-new for Fedora 7 onwards

* Mon Dec 11 2006 Paul Howarth <paul@city-fan.org> 3.2-3
- fixup build in mock with no python in initial buildroot
- don't %%ghost .pyo files

* Tue Sep 12 2006 Paul Howarth <paul@city-fan.org> 3.2-2
- fix dist tag for development builds
- add python-devel buildreq for tools subpackage

* Mon Jul  3 2006 Paul Howarth <paul@city-fan.org> 3.2-1
- update to 3.2
- tag builds on CentOS and Whitebox as RHEL
- new URL
- tmake no longer needed, but flex-new is
- major spec rewrite due to significant upstream changes
- put tools in separate subpackage

* Tue Jun 21 2005 Paul Howarth <paul@city-fan.org> 3.1-2
- set TMAKEPATH explicitly before building
- don't use a specific sf.net mirror for SOURCE0 URL
- fix build for 3.3 > qt >= 3.0

* Thu Mar 31 2005 Paul Howarth <paul@city-fan.org> 3.1-1
- initial RPM build
